models/Enroll.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "enroll".
 *
 * @property int $enroll_id
 * @property int|null $enroll_userid
 * @property int|null $enroll_courseid
 * @property int|null $enroll_cs
 * @property string|null $enroll_remark
 * @property string|null $enroll_created_at
 * @property int|null $enroll_created_by
 * @property string|null $enroll_modified_at
 * @property int|null $enroll_modified_by
 * @property int $enroll_status
 *
 * @property Courses $enrollCourse
 * @property Users $enrollUser
 */
class Enroll extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'enroll';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['enroll_userid', 'enroll_courseid', 'enroll_cs', 'enroll_created_by', 'enroll_modified_by', 'enroll_status', 'enroll_is_deleted'], 'integer'],
            [['enroll_created_at', 'enroll_modified_at'], 'safe'],
            [['enroll_remark'], 'string', 'max' => 100],
            [['enroll_courseid'], 'exist', 'skipOnError' => true, 'targetClass' => Courses::className(), 'targetAttribute' => ['enroll_courseid' => 'course_id']],
            [['enroll_userid'], 'exist', 'skipOnError' => true, 'targetClass' => Users::className(), 'targetAttribute' => ['enroll_userid' => 'user_id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'enroll_id' => 'Enroll ID',
            'enroll_userid' => 'Enroll Userid',
            'enroll_courseid' => 'Enroll Courseid',
            'enroll_cs' => 'Enroll Cs',
            'enroll_remark' => 'Enroll Remark',
            'enroll_created_at' => 'Enroll Created At',
            'enroll_created_by' => 'Enroll Created By',
            'enroll_modified_at' => 'Enroll Modified At',
            'enroll_modified_by' => 'Enroll Modified By',
            'enroll_status' => 'Enroll Status',
            'enroll_is_deleted' => 'Enroll Status',
        ];
    }

    /**
     * Gets query for [[EnrollCourse]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getEnrollCourse()
    {
        return $this->hasOne(Courses::className(), ['course_id' => 'enroll_courseid']);
    }

    public function getEnrollSectionCount()
    {
        return $this->hasMany(CourseSection::className(), ['course_id' => 'enroll_courseid'])->count('course_id');
    }

    public function getEnrollProgress()
    {
        $sectionCount = $this->hasMany(CourseSection::className(), ['course_id' => 'enroll_courseid'])->count('course_id');
        if($sectionCount<1){$sectionCount=1;}
        $progressCount = $this->hasMany(EnrollProgress::className(), ['ep_enroll_id' => 'enroll_id'])->where(['ep_status' => 1])->count('ep_status');
        return  round( (( $progressCount / $sectionCount ) * 100) , 2) ;

    }

    public function getEnrollProgressText()
    {
        $sectionCount = $this->hasMany(CourseSection::className(), ['course_id' => 'enroll_courseid'])->count('course_id');
        if($sectionCount<1){$sectionCount=1;}
        $progressCount = $this->hasMany(EnrollProgress::className(), ['ep_enroll_id' => 'enroll_id'])->where(['ep_status' => 1])->count('ep_status');
        return  $progressCount ."/". $sectionCount;

    }

    /**
     * Gets query for [[EnrollUser]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getEnrollUser()
    {
        return $this->hasOne(Users::className(), ['user_id' => 'enroll_userid']);
    }
}

controllers/EnrollController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Enroll;
use app\models\EnrollSearch;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EnrollController implements the CRUD actions for Enroll model.
 */
class EnrollController extends Controller
{

    public $layout = 'dashboard';
    
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['post'],
                ],
            ],
        ];
    }

    /**
     * Lists all Enroll models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new EnrollSearch;
        $dataProvider = $searchModel->search(Yii::$app->request->getQueryParams());

        return $this->render('index', [
            'dataProvider' => $dataProvider,
            'searchModel' => $searchModel,
        ]);
    }

    /**
     * Displays a single Enroll model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->enroll_id]);
        } else {
            return $this->render('view', ['model' => $model]);
        }
    }

    /**
     * Creates a new Enroll model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Enroll;

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->enroll_id]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Enroll model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->enroll_id]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Enroll model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Enroll model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Enroll the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Enroll::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

views/enroll/_form.php
<?php

use yii\helpers\Html;
use kartik\widgets\ActiveForm;
use kartik\builder\Form;
use kartik\datecontrol\DateControl;

/**
 * @var yii\web\View $this
 * @var app\models\Enroll $model
 * @var yii\widgets\ActiveForm $form
 */
?>

<div class="enroll-form">

    <?php $form = ActiveForm::begin(['type' => ActiveForm::TYPE_HORIZONTAL]); echo Form::widget([

        'model' => $model,
        'form' => $form,
        'columns' => 2,
        'attributes' => [

            'enroll_userid' => ['type' => Form::INPUT_TEXT, 'options' => ['placeholder' => 'Enter Enroll Userid...']],

            'enroll_courseid' => ['type' => Form::INPUT_TEXT, 'options' => ['placeholder' => 'Enter Enroll Courseid...']],

            'enroll_cs' => ['type' => Form::INPUT_TEXT, 'options' => ['placeholder' => 'Enter Enroll Cs...']],

            'enroll_status' => ['type' => Form::INPUT_TEXT, 'options' => ['placeholder' => 'Enter Enroll Status...']],

            'enroll_remark' => ['type' => Form::INPUT_TEXT, 'options' => ['placeholder' => 'Enter Enroll Remark...', 'maxlength' => 100]],

        ]

    ]);

    echo Html::submitButton($model->isNewRecord ? Yii::t('app', 'Create') : Yii::t('app', 'Update'),
        ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']
    );
    ActiveForm::end(); ?>

</div>

views/enroll/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/**
 * @var yii\web\View $this
 * @var app\models\EnrollSearch $model
 * @var yii\widgets\ActiveForm $form
 */
?>

<div class="enroll-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <?= $form->field($model, 'enroll_id') ?>

    <?= $form->field($model, 'enroll_userid') ?>

    <?= $form->field($model, 'enroll_courseid') ?>

    <?= $form->field($model, 'enroll_cs') ?>

    <?= $form->field($model, 'enroll_remark') ?>

    <?php // echo $form->field($model, 'enroll_created_at') ?>

    <?php // echo $form->field($model, 'enroll_created_by') ?>

    <?php // echo $form->field($model, 'enroll_modified_at') ?>

    <?php // echo $form->field($model, 'enroll_modified_by') ?>

    <?php // echo $form->field($model, 'enroll_status') ?>

    <div class="form-group">
        <?= Html::submitButton('Search', ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton('Reset', ['class' => 'btn btn-default']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/enroll/create.php
<?php

use yii\helpers\Html;

/**
 * @var yii\web\View $this
 * @var app\models\Enroll $model
 */

$this->title = 'Create Enroll';
$this->params['breadcrumbs'][] = ['label' => 'Enrolls', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="enroll-create">

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/enroll/index.php
<?php

use yii\helpers\Html;
use kartik\grid\GridView;
use yii\widgets\Pjax;

/**
 * @var yii\web\View $this
 * @var yii\data\ActiveDataProvider $dataProvider
 * @var app\models\EnrollSearch $searchModel
 */

$this->title = 'Enrolls';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="enroll-index">

    <p>
        <?php echo Html::a('<span class="fa fa-plus"></span> Add', ['create'], ['class' => 'btn btn-success'])  ?>
    </p>

    <?php Pjax::begin();
    echo GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'enroll_userid',
            'enroll_courseid',
            'enroll_cs',
            'enroll_remark',


            [
                'class' => 'yii\grid\ActionColumn',
                'buttons' => [
                    'view' => function ($url, $model) {
                        return Html::a(
                            '<span class="fa fa-search"></span>',
                            Yii::$app->urlManager->createUrl(['enroll/view', 'id' => $model->enroll_id, 'view' => 't']),
                            ['title' => Yii::t('yii', 'View'),]
                        );
                    },
                    'update' => function ($url, $model) {
                        return Html::a(
                            '<span class="fa fa-edit"></span>',
                            Yii::$app->urlManager->createUrl(['enroll/update', 'id' => $model->enroll_id, 'edit' => 't']),
                            ['title' => Yii::t('yii', 'Edit'),]
                        );
                    },
                    'delete' => function ($url, $model) {
                        return Html::a(
                            '<span class="fa fa-trash"></span>',
                            Yii::$app->urlManager->createUrl(['enroll/delete', 'id' => $model->enroll_id, 'delete' => 't']),
                            ['title' => Yii::t('yii', 'Delete'),]
                        );
                    }
                ],
            ],
        ],
        'responsive' => true,
        'hover' => true,
        'condensed' => true,
        'floatHeader' => true,
        'pjax' => true,
        'pjaxSettings' => [
            'neverTimeout' => true,
        ],
        'pager' => [
            'activePageCssClass' => 'active',
            'pageCssClass' => 'page-item',
            'disabledPageCssClass' => 'page-item disabled',
            'disabledListItemSubTagOptions' =>  [
                'class' => 'page-link',
            ],
            'linkOptions' => [
                'class' => 'page-link',
            ],
            'options' => [
                'class' => 'pagination justify-content-center m-0'
            ],
            'firstPageLabel' => '<span class="fa fa-fast-backward"></span>',
            'lastPageLabel' => '<span class="fa fa-fast-forward"></span>',
            'nextPageLabel' => '<span class="fa fa-step-forward"></span>',
            'prevPageLabel' => '<span class="fa fa-step-backward"></span>',
        ],
    ]);
    Pjax::end(); ?>

</div>

views/enroll/update.php
<?php

use yii\helpers\Html;

/**
 * @var yii\web\View $this
 * @var app\models\Enroll $model
 */

$this->title = 'Update Enroll';
$this->params['breadcrumbs'][] = ['label' => 'Enrolls', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->enroll_id, 'url' => ['view', 'id' => $model->enroll_id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="enroll-update">

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/enroll/view.php
<?php

use yii\helpers\Html;
use kartik\detail\DetailView;
use kartik\datecontrol\DateControl;

/**
 * @var yii\web\View $this
 * @var app\models\Enroll $model
 */

$this->title = "View Enroll";
$this->params['breadcrumbs'][] = ['label' => 'Enrolls', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="enroll-view">

    <?= DetailView::widget([
        'model' => $model,
        'condensed' => false,
        'hover' => true,
        'mode' => Yii::$app->request->get('edit') == 't' ? DetailView::MODE_EDIT : DetailView::MODE_VIEW,
        'attributes' => [
            'enroll_userid',
            'enroll_courseid',
            'enroll_cs',
            'enroll_remark',
            'enroll_status',
        ],
        'deleteOptions' => [
            'url' => ['delete', 'id' => $model->enroll_id],
        ],
        'enableEditMode' => false,
    ]) ?>

</div>